#include <cglib/core/glheaders.h>
#include <cglib/core/assert.h>

#include <cglib/gl/device_rendering_context.h>
#include <cglib/gl/device_render.h>
#include <cglib/gl/renderer.h>

int get_default_landscape_quality_reduction() { return 1; }

int
main(int argc, char const**argv)
{
	DeviceRenderingContext context;
    if (!context.params.parse_command_line(argc, argv)) {
        std::cerr << "invalid command line argument" << std::endl;
        return -1;
    }
	context.renderers.insert({DeviceRenderingParameters::SHADOW_MAP,           std::make_shared<ShadowmapRenderer>()});
	context.renderers.insert({DeviceRenderingParameters::FIRE_PLACE,           std::make_shared<FirePlaceRenderer>()});
	context.renderers.insert({DeviceRenderingParameters::PROCEDURAL_LANDSCAPE, std::make_shared<ProceduralLandscapeRenderer>()});

    return DeviceRender::run(context, true);
}
// CG_REVISION ff142e1d85946afdd3443ac91f9194d278236dc9
